%% /home/csc-sun/a/sy/beebe/src/lex/cweb/expr2.ch, Wed May 29 12:26:06 1991
%% Edit by Nelson H.F. Beebe <beebe@@glab1.math.utah.edu>

This is the change file to convert expr into
expr2, a version of the expression parser that
recognizes power operators.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
We need one more macro than before.  We also want
to see in the TeX output only the changes from
the original program

@x
\def\ctangle{\.{ctangle}}
@y
\let\maybe=\iffalse

\def\caret{\char`\^}

\def\ctangle{\.{ctangle}}
@z

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Update the running page headers.

@x
\def\title{EXPR}  % used in the page headers
@y
\def\title{EXPR2} % used in the page headers
@z

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Update the document title page.
@x
  \centerline{\titlefont
    {\ttitlefont EXPR}---A
    Simple Expression Parser}
@y
  \centerline{\titlefont
    {\ttitlefont EXPR}---A
    Simple Expression Parser}
  \centerline{Version 2}
@z

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Here are the initial grammar modifications.

@x
\+        T & : &T * F\cr
\+           & \vbar & T / F\cr
\+           & \vbar & F\cr
@y
\+        T & : &T * P\cr
\+           & \vbar & T / P\cr
\+           & \vbar & P\cr

\+        P & : &F \caret P\cr
\+           & \vbar & F\cr
@z

Here are the final (non-left-recursive) grammar
changes.

@x
\+        T & : &F T'\cr

\+        T' & : &* F\cr
\+            & \vbar & / F\cr
\+            & \vbar & \langle empty\rangle\cr
@y
\+        T & : &P T'\cr

\+        T' & : &* P\cr
\+            & \vbar & / P\cr
\+            & \vbar & \langle empty\rangle\cr

\+        P & : &F \caret P\cr
\+           & \vbar & F\cr
@z

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
We need one more function declaration.

@x
int     peeknb @, ARGS((void));@/
@y
int     peeknb @, ARGS((void));@/
double  power @, ARGS((void));@/
@z

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Add a no-op change to work around a TeX error.
@x
@* The expression parser.
@y
@* The expression parser.
@z



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Add a section describing the implementation of
the power rule.

@x
@ The factor rule, F, in the grammar
@y
@ The power rule, P, in the grammar

\+        P & : &F \caret P\cr
\+           & \vbar & F\cr

\noindent 
translates to a |for(;;)| loop to handle operator
lookahead.  Return occurs when no further power
operators are found.

@c @<Parse a power@>

@ @<Parse a power@>=
double
power()
{
    double p = factor();

    for (;;)
    {
        if (peeknb() == '^')
            nextnb(), p = pow(p,power());
        else
            return (p);
    }
}

@ The factor rule, F, in the grammar
@z

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Add a no-op change to work around a TeX error.

@x
@ The third part of the expression grammar defines
@y
@ The third part of the expression grammar defines
@z

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
In term(), we now get powers instead of factors.

@x
    double t = factor();
@y
    double t = power();
@z

@x
        if (peeknb() == '*')
            nextnb(), t *= factor();
        else if (peeknb() == '/')
            nextnb(), t /= factor();
@y
        if (peeknb() == '*')
            nextnb(), t *= power();
        else if (peeknb() == '/')
            nextnb(), t /= power();
@z

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Finally, we have a different file name.

@x
\input expr.toc % Make the title page and table of contents
@y
\input expr2.toc % Make the title page and table of contents
@z
