.TH STOD 1L "09 April 1991"
.\"======================================================================
.SH "NAME"
stod \- convert Fortran program from single-precision to double-precision
.\"======================================================================
.SH "SYNOPSIS"
.B stod
< infile >outfile
.PP
.B stod
copies its standard input to standard output,
converting Fortran single-precision constants,
built-in functions, and type declarations to
double precision.
.PP
Floating-point FORMAT specifications are left
intact; on some ancient systems, they may require
modifications.  They do
.I not
under the rules of Fortran 77.
.PP
Leading tabs are correctly interpreted according
to common extended Fortran rules.
.PP
.BR stod 's
other purpose is to demonstrate a modest
.BR lex (1)
program.
.\"======================================================================
.SH "BUGS"
Undeclared variables are not type-converted.  To find 
such instances, use the Extended PFORT Verifier, 
.BR pfort (1),
or the Fortran checker,
.BR forchek (1).
.PP
The input files should not contain any text past
column 72; if they do, that text may be incorrectly
wrapped onto continuation lines.
.PP
.B stod
does not understand Fortran string constants, and
may incorrectly do substitutions inside them.  It
is always a good idea to use
.BR diff (1)
on the input and output files before accepting the
conversion as correct.
.PP
.B stod
does not handle embedded ASCII tab characters
correctly when long lines are to be broken.  A
Fortran-sensitive detabbing utility should be
applied first if the input file possibly contains
embedded tabs.  Note that
.BR expand (1)
.I cannot
be used to do this job correctly!
.PP
Similarly, multi-line strings may be disturbed if
the processing changes their length, necessitating
generation of an intermediate continuation line.
Such instances are usually rare, and can be
patched by hand.
.\"======================================================================
.SH "SEE ALSO"
.BR dtos (1),
.BR forchek (1),
.BR lex (1),
.BR pfort (1).
.\"======================================================================
.SH "AUTHOR"
Nelson H. F. Beebe, Ph.D.
.br
Center for Scientific Computing
.br
Department of Mathematics
.br
South Physics Building
.br
University of Utah
.br
Salt Lake City, UT 84112
.br
Tel: (801) 581-5254
.br
FAX: (801) 581-4148
.br
Email: <beebe@science.utah.edu>
.\"==============================[The End]==============================
