	/* wl (word length) -- print a table of word lengths from stdin */
%{
#undef yywrap		/* in case we use flex instead of lex */
long count[100];	/* count[k] holds count of words of length k */
%}

%%
[_A-Za-z]+	count[yyleng]++;
.	|
\n	;
%%
yywrap()
{
    int i;
    long n;
    long max_count;
    long total;

    for (max_count = 0, total = 0, i = 0; i < 100; i++)
    {
	max_count = (count[i] > max_count) ? count[i] : max_count;
	total += count[i];
    }

    printf("Length  Word Count (total = %ld)\n",total);

    for (i = 0; i < 100; i++)
    {
        if (count[i] > 0)
	{
	    printf("%4d%8ld%5.1lf%%", i, count[i],
		100.0 * (double)count[i]/(double)total);
	    putchar(' ');
	    for (n = 60L*count[i], n /= max_count; n > 0; --n)
	        putchar('#');
	    putchar('\n');
	}
    }
    return (i);    
}

